/**
 * 
 */
package com.ejie.ad74a.process;

import java.util.Arrays;
import java.util.Calendar;
import java.util.stream.Collectors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.ejie.ad74a.exception.BatchProcessException;
import com.ejie.ad74a.model.Procesos;
import com.ejie.ad74a.service.BenDiputacionesService;
import com.ejie.ad74a.service.ProcesosService;
import com.ejie.ad74a.util.UtilDates;
import com.ejie.ad74a.util.constantes.EstadosProcesosBatchEnum;
import com.ejie.ad74a.util.constantes.ProcesosBatchEnum;

/**
 * Proceso para la generacion del ficheros de intercambio con Diputaciones.
 *  
 * @author IHERNANG
 *
 */
@Component(value = "benDiputaciones")
public class BenDiputacionesProcess implements IProcess {

	private static final Logger logger = LoggerFactory.getLogger(BenDiputacionesProcess.class);
	
	@Autowired
	ProcesosService procesosService;
	
	@Autowired
	BenDiputacionesService benDiputacionesService;

	/**
	 * Metodo de ejecucion del proceso.
	 * 
	 * @param arg[0] : 1, 20, 48 para indicar la provincia
	 * @param arg[1] : idProceso tabla AD74A98T00 (opcional)
	 * 
	 * Formato del par�metro: @@provincia@@idProceso@@
	 */
	@Override
	public void execute(String... args) throws BatchProcessException {

		
		Procesos proceso = new Procesos();		
		try {
			String params = Arrays.asList(args).stream().map(i -> i).collect(Collectors.joining(", "));
			
			logger.debug("Params: {}", params);
			
			
			String prov = args.length >= 1 ? args[0] : null;
			String idProceso = args.length == 2 ? args[1] : null;
			
			if(null != prov) {				
				// Buscar si existe el proceso en bbdd
				boolean addProceso = false;
				if(idProceso == null || "".equals(idProceso)) {
					addProceso = true;
				} else {
					proceso = new Procesos(Long.valueOf(idProceso));
					proceso = this.procesosService.find(proceso);
					addProceso = null == proceso? true: false;					
				}	
				
				if(addProceso) {
					Calendar calendar = Calendar.getInstance();
					calendar.setTime(UtilDates.getFechaSistema());
					// Creamos un proceso nuevo
					// 1- Insertar el nuevo proceso en la tabla AD74A98T00
					proceso = new Procesos();
					proceso.setEstado98(EstadosProcesosBatchEnum.PENDIENTE.getId());
					proceso.setUsuAlta98("AD74A");				
					proceso.setTipoProceso98(ProcesosBatchEnum.BEN_DDFF.getId());
					proceso.setProceso98(calendar.get(Calendar.YEAR) 
							+ "" + String.format("%02d" , (calendar.get(Calendar.MONTH) + 1)) 
							+ "" + String.format("%02d" , calendar.get(Calendar.DAY_OF_MONTH)) + "_" + prov 
							);
					proceso = this.procesosService.add(proceso);
				}
				
				this.procesosService.actualizarAIniciado(proceso);			
				this.benDiputacionesService.generarXMLBeneficiarios(prov);			
				this.procesosService.actualizarAFinalizado(proceso);	
			}else {
				logger.debug("Falta el par�metro de la provincia. No se ejecuta nada");
			}
			
		} catch (Exception e) {
			if(proceso != null && proceso.getIdProceso98() != null) {				
				proceso.setError98(e.getMessage().substring(0, Math.min(e.getMessage().length(), 799))); // M�ximo 800
				this.procesosService.actualizarAError(proceso);
			}
			throw new BatchProcessException(e);
		}

	}

}
